'use client'
import { useMutation } from '@tanstack/react-query'
import { toISOIfNotZ } from '@/lib/utils';
import { BuildAreasAdd } from './schema';

const fetchGraphQlBuildSitesAdd = async (record: BuildAreasAdd, buildId: string): Promise<{ data: BuildAreasAdd | null; status: number }> => {
    console.log('Fetching test data from local API');
    record.expiryStarts = record.expiryStarts ? toISOIfNotZ(record.expiryStarts) : undefined;
    record.expiryEnds = record.expiryEnds ? toISOIfNotZ(record.expiryEnds) : undefined;
    try {
        const res = await fetch('/api/build-areas/add', { method: 'POST', cache: 'no-store', credentials: "include", body: JSON.stringify({ ...record, buildId }) });
        if (!res.ok) { const errorText = await res.text(); console.error('Test data API error:', errorText); throw new Error(`API error: ${res.status} ${res.statusText}`) }
        const data = await res.json();
        return { data: data.data, status: res.status }
    } catch (error) { console.error('Error fetching test data:', error); throw error }
};

export function useAddBuildAreasMutation() {
    return useMutation({
        mutationFn: ({ data, buildId }: { data: BuildAreasAdd, buildId: string }) => fetchGraphQlBuildSitesAdd(data, buildId),
        onSuccess: () => { console.log("Build areas created successfully") },
        onError: (error) => { console.error("Add build areas failed:", error) },
    })
}
